/******************************************************************************/
/*                                                                            */
/* POLiTe - Persistent Object Library Test                                    */
/*                                        Ph.D. Thesis by Mgr. Michal Kopecky */
/*                                                                            */
/* Charles University Prague                                                  */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* File name: ... lDefs.h                                                     */
/* Module: ...... none                                                        */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* lDefsX.h : Declares platform dependent                                     */
/*            preprocessor label definitions for the library                  */
/*                                                                            */
/******************************************************************************/


#ifndef __L_DEFSX_H__
#define __L_DEFSX_H__


/* if compiled by MSVC or BC++, define macro DLL_External */
/* application pre-defines it as __declspec(dllimport) */
#if defined(_MSC_VER) || defined (__BORLANDC__)
# ifndef DLL_EXTERNAL
#  ifndef BUILD_DLL
#   define DLL_EXTERNAL __declspec(dllimport)
#  else
#   define DLL_EXTERNAL __declspec(dllexport)
#  endif
# endif
#else
# define DLL_EXTERNAL
#endif

/* Switch the database connectivity off */

/*
#ifndef NO_DATABASE_PRESENT
#define NO_DATABASE_PRESENT
#endif
*/

#endif /*__L_DEFSX_H__*/
