#ifndef DATABASEOBJECT_H_
#define DATABASEOBJECT_H_

#include "iopcmeta/enhancedString.h"
#include "iopcmeta/enhancedNumber.h"
#include "iopcmeta/object.h"
#include "iopccommon/defs.h"
#include "iopcdb/connection.h"
#include "iopcmeta/typeDesc.h"
#include "iopcmeta/metaSupport.h"
#include <map>
#include <string>

namespace iopc {

//typedef std::map<std::string, Object> KeyValuesType;

class DLL_EXTERNAL DatabaseObject : public Object {

private:
	static void iopcInit(iopc::Type& t) {
		/*t["db.table"] = "DatabaseObject";
		//t.getAttribute("oid")["db.sequence"] = "OIDSEQ";
		t.getAttribute("oid")["db.column"] = "OID";
		t.getAttribute("oid")["db.primaryKey"].setBoolValue(true);
		t.getAttribute("oid")["db.viewColumn"] = "OID";
		t.getAttribute("className")["db.column"] = "CLASSNAME";
		t.getAttribute("className")["db.type.length"] = 1000;
		t.getAttribute("className")["db.viewColumn"] = "CLASSNAME";
		t.getAttribute("serialId")["db.column"] = "SERIALID";
		t.getAttribute("serialId")["db.viewColumn"] = "SERIALID";*/
	}

	bool initializedAfterLoad;
protected:
	void onIopcCreate();

public:
	/*OidType oid;
	EString className;
	SerialIdType serialId;*/

	DatabaseObject();

	virtual void onCreate() {};
	//virtual void onLoad() {};
	// TODO: create remaining events.. onCacheDelete etc...


	inline virtual bool isDatabaseObject() {
		return true;
	};

	inline virtual bool isOidObject() {
		return false;
	};

	virtual ~DatabaseObject() {};



	friend class DbPtrBase; // onIopcCreate();
	friend class TypeDesc<DatabaseObject>;
};

// TypeDesc for OidType

}

// generate TypeDesc
META_BLOCK1(iopc::DatabaseObject)
META_PARENT1(iopc::Object)
META_BLOCK2(iopc::DatabaseObject)
META_BLOCK3(iopc::DatabaseObject, DatabaseObject, iopc)
META_INIT(iopc::DatabaseObject)
META_BLOCK4

#endif /*DATABASEOBJECT_H_*/
