#ifndef IOPCMETA_H_
#define IOPCMETA_H_

#include "metadataInitializer.h"
#include "iopccommon/trace.h"

namespace iopc {

class IopcMeta {
	private:
		static MetadataInitializer* initializer;


	public:
		static void init(
				int traceMaskTTY = LogWriter::defaultTraceMaskTTY,
				int traceMask = LogWriter::defaultTraceMask,
				const std::string& logFileName = LogWriter::defaultFileName);
		static void init(
				MetadataInitializer* metadataInitializer,
				int traceMaskTTY = LogWriter::defaultTraceMaskTTY,
				int traceMask = LogWriter::defaultTraceMask,
				const std::string& logFileName = LogWriter::defaultFileName);

		static void shutdown();

};


}

#endif /*IOPCMETA_H_*/
