/**
 * @file iopcCommon.h
 *
 * @author Petr Cermak
 */

#ifndef IOPCCOMMON_H_
#define IOPCCOMMON_H_

#include "trace.h"

namespace iopc {

class IopcCommon {

public:
	static void init(int traceMaskTTY = LogWriter::defaultTraceMaskTTY,
			int traceMask = LogWriter::defaultTraceMask,
			const std::string& logFileName = LogWriter::defaultFileName);
	static void shutdown();

//	static bool isInitialized(bool initialized = false);
};

}


#endif /*IOPCCOMMON_H_*/
